-- Modul JOCS D'ORDINADOR (games)
-- Programadors: Sergio Blanco Cuaresma    (E.T.I. Gesti)
--               Francesc Galiano Baixauli (E.T.I. Gesti)
-- Data: Mar 2001
--
-- Aquest modul conte les funcions necesaries per manipular una base
-- de dades de jocs. Inicialitza, busca, afegeix jocs, canvia records,
-- afegeix partides, llista...
-- *****************************************************************

package games is

	type basedades is private;

	procedure init(jocs: in out basedades);
	procedure afegir(jocs: in out basedades);
	procedure afegir_partides(jocs: in out basedades; nom: in string; partides: in natural);
	procedure nou_record(jocs: in out basedades; nom: in string; nrecord: in natural);
	
	function totaljocs(jocs: basedades) return integer;
	function trobar(jocs: basedades; nom: string) return boolean;
	procedure llistar(jocs: in basedades);
	procedure mostrar(jocs: in basedades; nom: in string);
	procedure minpartides(jocs: in basedades; partides: in natural);
	procedure any(jocs: in basedades; any: natural);
	
	private
		subtype dia_sub is integer range 1..31;
		subtype mes_sub is integer range 1..12;
	
		type data_model is record
			dia: dia_sub;
			mes: mes_sub;
			any: natural;
		end record;
		
		type fitxa is record
			nom: string(1..30);
			data: data_model;
			preu: natural;
			partides: natural;
			maxpunts: natural;
		end record;
	
		type fitxer_generic is array (1..500) of fitxa;

		type basedades is record
			total: natural;
			fitxer: fitxer_generic;
		end record;

end games;
	
	
	