-- Programa de prova del modul JOCS D'ORDINADOR (games)
-- Programadors: professors de l'assignatura de PR1 curs 2000-01
-- ** Modificat per Sergio Blanco Cuaresma i Francesc Galiano Baixauli
-- Data: Mar 2001

-- A les linies amb comentaris que comencen per un '!' cal posar-hi
-- les crides corresponents al vostre paquet.
-- *****************************************************************

with Ada.Text_IO; use Ada.Text_IO;
with games; use games; -- ! Incloure el vostre mdul

procedure provar is

 -- S'ha de definir el integers i no els positive (pq funcioni totaljocs)
 package enter_io is new ada.text_io.integer_io(integer); use enter_io;
 

 type opcions is (a,b,c,d,e,f,g,h,i,s);

 package opcions_IO is new Ada.Text_IO.Enumeration_IO(opcions);
 use opcions_IO;
 
 -- Subprograma que llegeix del teclat un string fins que troba 
 -- que s'ha premut el RETURN (o INTRO)
 -- Omple la resta del string fins al final amb espais en blanc
 procedure llegir (frase:out string) is
 long:positive;
 begin
   get_line(frase,long);
   for i in long+1..frase'last loop
      frase(i):=' ';
   end loop;
 end llegir;

-- Variables que s'usen al programa principal
op:opcions:=a;
els_meus_jocs: basedades; --llista_jocs por basedades
num:natural;
nom:string(1..30);

begin

  init(els_meus_jocs); -- ! inicialitzar la variable els_meus_jocs
  put("Programa de gestio de jocs d'ordinador"); new_line;

  -- Menu de l'aplicacio
  while op/=s loop
     put("a. Introduir un nou joc"); new_line;
     put("b. Afegir partides a un joc"); new_line;
     put("c. Canviar el record d'un joc"); new_line;
     put("d. Quants jocs tinc?"); new_line;
     put("e. Comprovar si tinc un cert joc"); new_line;
     put("f. Quins jocs vaig comprar l'any ... ?"); new_line;
     put("g. En quins jocs he jugat mes de ... partides?"); new_line;
     put("h. Quina informacio tinc del joc ...?"); new_line;
     put("i. Llistar tots el jocs"); new_line;
     put("s. SORTIR"); new_line;

     get(op);
     skip_line;
     case op is
       when a => afegir(els_meus_jocs);
       	-- ! Subprograma per afegir jocs
       when b => put("Nom del joc? "); llegir(nom);
                 put("Quantes partides has fet? "); get(num);
                 afegir_partides(els_meus_jocs, nom, num);
                 -- ! subprograma per sumar partides
       when c => put("Nom del joc? "); llegir(nom);
                 put("Quin es el nou record? "); get(num);
                 nou_record(els_meus_jocs, nom, num);
                 -- ! subprograma per canviar el record
       when d => put("Total: ");put(totaljocs(els_meus_jocs), width=>3);new_line;
       	     -- ! mostrar el num_jocs que tinc 
       when e => put("Nom del joc: "); llegir(nom);
       		  if (trobar(els_meus_jocs,nom)=true) then
       		  	put("Si el tinc.");
       		  else
       		  	put("No el tinc.");
       		  end if;
                 -- ! mostrar un missatge que digui si tinc o no
                 --   el joc que acabo d'entrar per teclat (nom)
       when f => put("Any: "); get(num);
       		  any(els_meus_jocs, num);
                 -- ! subprograma que mostra els jocs comprats l'any indicat
       when g => put("Num partides: "); get(num);
       		  minpartides(els_meus_jocs, num);
                 -- ! subprograma que mostra el jocs amb el que he
                 --   fet ms de num partides
       when h => put("Nom joc: "); llegir(nom);
       		  mostrar(els_meus_jocs, nom);
                 -- subprogram que mostra la info del joc indicat
       when i => llistar(els_meus_jocs);
       when others => null;
     end case;
     new_line;
  end loop;

  exception
	when data_error => put_line("> Valor incorrecte!!");
	when constraint_error => put_line("> Valor fora de rang!!");
        
end provar;